IDA SDK

- Main Page
- Header Files
- Classes
- Modules

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Attributes | Public Member Functions | List of all members
idainfo Struct Reference

## Detailed Description

The database parameters.

This structure is kept in the ida database. It contains the essential parameters for the current program

## Public Attributes
char | tag [3]
| 'IDA'
ushort | version
| Version of database.
char | procName [8]
| Name of current processor The terminating zero may be absent if the processor name is too long!
uchar | lflags
| Misc. database flags
uchar | demnames
| Demangled name flags
ushort | filetype
| The input file type.
uval_t | fcoresiz
| size of input file core image used to create executable file
uval_t | corestart
| start of pages to load (offset in the file)
ushort | ostype
| OS type the program is for bit definitions in libfuncs.hpp.
ushort | apptype
| Application type bit definitions in libfuncs.hpp.
ea_t | startSP
| SP register value at the start of program execution.
ushort | af
| Analysis flags
ea_t | startIP
| IP register value at the start of program execution.
ea_t | beginEA
| Linear address of program entry point.
ea_t | minEA
| current limits of program
ea_t | maxEA
| maxEA is excluded
ea_t | ominEA
| original minEA (is set after loading the input file)
ea_t | omaxEA
| original maxEA (is set after loading the input file)
ea_t | lowoff
| Low limit for offsets (used in calculation of 'void' operands)
ea_t | highoff
| High limit for offsets (used in calculation of 'void' operands)
uval_t | maxref
| Max tail for references.
uchar | ASCIIbreak
| ASCII line break symbol.
bool | wide_high_byte_first
| Bit order of wide bytes: high byte first? (wide bytes: processor_t::dnbits > 8)
uchar | indent
| Indention for instructions.
uchar | comment
| Indention for comments.
uchar | xrefnum
| Number of references to generate in the disassembly listing 0 - xrefs won't be generated at all.
bool | s_entab
| Use '' chars in the output file?
uchar | specsegs
| What format do special segments use? 0-unspecified, 4-entries are 4 bytes, 8- entries are 8 bytes.
bool | s_void
| Display void marks?
uchar | type_xrefnum
| Number of references to generate in the struct & enum windows 0 - xrefs won't be generated at all.
bool | s_showauto
| Display autoanalysis indicator?
bool | s_auto
| Autoanalysis is enabled?
uchar | s_limiter
| Delimiter options
uchar | s_null
| Generate empty lines?
uchar | s_genflags
| General idainfo flags
uchar | s_showpref
| Show line prefixes?
uchar | s_prefseg
| line prefixes with segment name?
uchar | asmtype
| target assembler number
uval_t | baseaddr
| base address of the program (paragraphs)
uchar | s_xrefflag
| Xref options
short | binSize
| # of instruction bytes to show in line prefix
uchar | s_cmtflg
| Comment options
char | nametype
| Dummy names representation types
uchar | s_showbads
| show bad instructions? an instruction is bad if it appears in the asm_t::badworks array
uchar | s_prefflag
| Line prefix options
uchar | s_packbase
| pack database?
uchar | asciiflags
| ASCII string flags
uchar | listnames
| Name list options
char | ASCIIpref [16]
| ASCII names prefix.
uval_t | ASCIIsernum
| serial number
char | ASCIIzeroes
| leading zeroes
uchar | graph_view
| currently using graph options ( text_options_t::graph)
uchar | s_reserved5
| old memory model & calling convention
uchar | tribyte_order
| tribyte_order_t: order of bytes in 3-byte items
bool | mf
| Byte order: is MSB first?
bool | s_org
| Generate 'org' directives?
bool | s_assume
| Generate 'assume' directives?
uchar | s_checkarg
| bit0: check manual operands? bit1: allow non-matched operands?
sel_t | start_ss
| selector of the initial stack segment
sel_t | start_cs
| selector of the segment with the main entry point
ea_t | main
| address of main()
uint32 | short_demnames
| short form of demangled names
uint32 | long_demnames
| long form of demangled names see demangle.h for definitions
uval_t | datatypes
| data types allowed in data carousel used in MakeData command. More...
int32 | strtype
| current ascii string type see nalt.hpp for string types
ushort | af2
| Analysis flags 2
ushort | namelen
| max name length (without zero byte)
ushort | margin
| max length of data lines
ushort | lenxref
| max length of line with xrefs
char | lprefix [16]
| prefix of local names if a new name has this prefix, it will be automatically converted to a local name
uchar | lprefixlen
| length of the lprefix
compiler_info_t | cc
| Target compiler.
uint32 | database_change_count
| incremented after each byte and regular segment modifications
uchar | size_ldbl
| sizeof(long double) if different from processor_t::tbyte_size
uint32 | appcall_options
| appcall options, see idd.hpp
char | abiname [16]
| ABI name. Processor specific field.
uint32 | abibits
| ABI features. More...
uchar | refcmtnum
| Number of comment lines to generate for refs to ASCII string or demangled name 0 - such comments won't be generated at all.
uchar | reserved [34]
| zero bytes for the future total size: 256 bytes (for 32bit)

## Public Member Functions
void | set_proc_name (const char *name)
| Set procName.
char * | get_proc_name (char *buf) const
| Get procName.
bool | is_32bit (void) const
| LFLG_PC_FLAT
bool | is_64bit (void) const
| LFLG_64BIT
bool | is_snapshot (void) const
| LFLG_SNAPSHOT
bool | is_dll (void) const
| LFLG_IS_DLL
bool | is_flat_off32 (void) const
| LFLG_FLAT_OFF32
uchar | get_demname_form (void) const
| Get DEMNAM_MASK bits of demnames.
bool | like_binary (void) const
| Is unstructured input file?
bool | use_allasm (void) const
| INFFL_ALLASM
bool | loading_idc (void) const
| INFFL_LOADIDC
bool | store_user_info (void) const
| INFFL_NOUSER
bool | readonly_idb (void) const
| INFFL_READONLY
bool | is_mem_aligned4 (void) const
bool | pack_stkargs (void) const
bool | big_arg_align (void) const
bool | stack_ldbl () const
bool | stack_varargs () const
bool | is_hard_float (void) const

## Member Data Documentation

uval_t idainfo::datatypes

data types allowed in data carousel used in MakeData command.

uint32 idainfo::abibits

ABI features.

Depends on inf{abiname} Processor modules may modify them in set_compiler

The documentation for this struct was generated from the following file:

- ida.hpp